]> git.proxmox.com Git - mirror_ubuntu-artful-kernel.git/blame - scripts/Makefile.gcc-plugins
x86/speculation: Rework speculative_store_bypass_update()
[mirror_ubuntu-artful-kernel.git] / scripts / Makefile.gcc-plugins
CommitLineData
6b90bd4b
ER
1ifdef CONFIG_GCC_PLUGINS
2 __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
3 PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
4
543c37cb
ER
5 SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
6
0dae776c 7 gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
543c37cb 8
38addce8
ER
9 gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so
10 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
7b4010ed 11 ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY
38addce8
ER
12 DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable
13 endif
14
543c37cb
ER
15 ifdef CONFIG_GCC_PLUGIN_SANCOV
16 ifeq ($(CFLAGS_KCOV),)
17 # It is needed because of the gcc-plugin.sh and gcc version checks.
18 gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
19
20 ifneq ($(PLUGINCC),)
21 CFLAGS_KCOV := $(SANCOV_PLUGIN)
22 else
23 $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
24 endif
25 endif
26 endif
27
c61f13ea
KC
28 gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += structleak_plugin.so
29 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE) += -fplugin-arg-structleak_plugin-verbose
30 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += -DSTRUCTLEAK_PLUGIN
31
313dd1b6
KC
32 gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += randomize_layout_plugin.so
33 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += -DRANDSTRUCT_PLUGIN
34 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
35
65d59ec8 36 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
6b90bd4b 37
38addce8
ER
38 export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
39 export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
6b90bd4b 40
ed58c0e9
KC
41 ifneq ($(PLUGINCC),)
42 # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
43 GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
44 endif
45
46 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
47 GCC_PLUGIN := $(gcc-plugin-y)
caefd8c9 48 GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
ed58c0e9
KC
49endif
50
51# If plugins aren't supported, abort the build before hard-to-read compiler
52# errors start getting spewed by the main build.
53PHONY += gcc-plugins-check
54gcc-plugins-check: FORCE
55ifdef CONFIG_GCC_PLUGINS
6b90bd4b
ER
56 ifeq ($(PLUGINCC),)
57 ifneq ($(GCC_PLUGINS_CFLAGS),)
65c059bc
AD
58 # Various gccs between 4.5 and 5.1 have bugs on powerpc due to missing
59 # header files. gcc <= 4.6 doesn't work at all, gccs from 4.8 to 5.1 have
60 # issues with 64-bit targets.
61 ifeq ($(ARCH),powerpc)
62 ifeq ($(call cc-ifversion, -le, 0501, y), y)
63 @echo "Cannot use CONFIG_GCC_PLUGINS: plugin support on gcc <= 5.1 is buggy on powerpc, please upgrade to gcc 5.2 or newer" >&2 && exit 1
64 endif
65 endif
6b90bd4b 66 ifeq ($(call cc-ifversion, -ge, 0405, y), y)
ed58c0e9
KC
67 $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
68 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
6b90bd4b 69 else
ed58c0e9 70 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
6b90bd4b
ER
71 endif
72 endif
73 endif
ed58c0e9
KC
74endif
75 @:
6b90bd4b 76
ed58c0e9
KC
77# Actually do the build, if requested.
78PHONY += gcc-plugins
79gcc-plugins: scripts_basic gcc-plugins-check
80ifdef CONFIG_GCC_PLUGINS
81 $(Q)$(MAKE) $(build)=scripts/gcc-plugins
6b90bd4b 82endif
ed58c0e9 83 @: